module Util where

lookup' x [] = 
    error "LookUp Failed"
lookup' x ((a,b):ls) 
    | a == x = b
    | a /= x = lookup' x ls

elemIndex' a xs = f 0 xs
    where
      f i (x:xs) 
        | x == a = i
        | x /= a = f (i+1) xs
      f i [] =
          error "ElemIndex Failes"


foldM1 :: Monad m => (a -> a -> m a) -> [a] -> m a
foldM1 f [x] = return x
foldM1 f (x:xs) = 
    do xs' <- foldM1 f xs
       f x xs'

concatMapM f [] = return []
concatMapM f (l:ls) =
    do x <- f l
       y <- concatMapM f ls
       return $ x ++ y


implode c [] = []
implode c [v] = v
implode c (x:xs) = x ++ c ++ implode c xs

